
//**********************************************************************
// 	Project: 
//	File: gamma_exp.v
// 	Description: test GAMMA 锛圙W_2A_18锛?
//	Author: wenxuan
//  Timestamp: 
//----------------------------------------------------------------------
// Code Revision History:
// Ver:		| Author 	| Mod. Date		| Changes Made:
// v1.0.0	|           	| xx/xx/2021	    | Initial version
//**********************************************************************


module AEAWB_exp(
// --- sym ---
	input    SYM_CLK,
// --- KEY ---
	input    KEY1,
// --- SW ----
	input    SW1,

	output			outvalid,
    output          line_sync_o,
    output          frame_sync_o,
	output [7:0]	dout
);

//**********************************************************************
// --- Parameter
//**********************************************************************
    localparam NUM_CYCLE = 4;
	localparam MEM_DEPTH = 64*48;
`define 	IMAGE_WIDTH 8	
//**********************************************************************
// --- Inter Signal Declaration
//**********************************************************************
    wire clk;
    // wire clk_100M;
	wire rstn;
	wire ce;
wire frame_sync;

    assign clk = SYM_CLK;
    assign rstn = KEY1;
	assign ce=SW1;

    wire						inpvalid;
    wire                        line_sync;
//	wire signed [17:0]	din;
	
//	wire recycle;
	reg pstart;
	reg [19:0] addr;
    reg [9:0] cnt_cycle;

    reg [7:0] data_mem [0:MEM_DEPTH-1] /* synthesis syn_romstyle= "block_rom" */;
    reg [7:0] din;
wire [31:0] rdata;
reg[7:0] addr_8;
//**********************************************************************
// --- Initial
//**********************************************************************

initial begin
           $readmemb("data.dat",data_mem);
end

assign inpvalid  = (addr ==1'b0) ? 1'b0 :(addr>=MEM_DEPTH+1) ? 1'b0 : (pstart && cnt_cycle == 0) ? 1'b1 : 1'b0 ;
assign line_sync = (addr>=MEM_DEPTH+1) ? 1'b0 : (pstart && (addr_8 == 0) && cnt_cycle == 0) ? 1'b1 : 1'b0 ;


assign frame_sync= (addr==0 && cnt_cycle==1 ) ? 1'b1: 1'b0;


    always @(posedge clk or negedge rstn) begin
        if(!rstn) cnt_cycle <= NUM_CYCLE-1;
        else if(ce) begin
			if(cnt_cycle == NUM_CYCLE-1 ) cnt_cycle <= 0;
            else if(cnt_cycle == NUM_CYCLE-1) cnt_cycle <= cnt_cycle;
            else cnt_cycle <= cnt_cycle + 1;
        end
    end

    always @(posedge clk or negedge rstn) begin
        if(!rstn) addr <= 20'hfffff;
//        else if(ce & pstart) begin
        else if(ce) begin
			if(cnt_cycle == NUM_CYCLE-1 && addr == MEM_DEPTH+128) addr <= 0;
            else if(cnt_cycle == NUM_CYCLE-1) addr <= addr + 1;
        end
    end

    always @(posedge clk ) begin
        if(!rstn) 
            addr_8 <= 8'h100;
        else if (addr>=15'hc01)
            addr_8<=100;
        else if (addr==0 || addr_8==255 )
            addr_8<=0;
        else
            addr_8 <= addr_8 + 1;
    end


	always @(posedge clk or negedge rstn) begin
        if(!rstn) pstart <= 1'b0;
        else if(ce) begin
            if(cnt_cycle == NUM_CYCLE-1) pstart <= 1'b1;
        end
    end
	
    always @(posedge clk or negedge rstn) begin
        if(!rstn) begin 
        din <= 0;
end
//        else if(ce & pstart) begin
        else if(ce ) begin
			if(cnt_cycle == NUM_CYCLE-1 && addr >= MEM_DEPTH) 
            begin
                din <= 0;
            end
            else if(cnt_cycle == NUM_CYCLE-1)
            begin
                din<=data_mem[addr];
            end
        end
    end

//**********************************************************************
// --- Module: top 
// --- Description:	top module of project
//**********************************************************************
AEAWB_Top AEAWB_Top (
    .clk(clk), 				// system clock
    .rstn(rstn),				// reset
    .ce(ce),
    .frame_sync(frame_sync),
    .line_sync(line_sync),
    .inpvalid(inpvalid),
    .din(din),
	.wr(1'b0), //input wr
	.rd(1'b0), //input wr
	.waddr(16'b0), //input [15:0] waddr
	.wdata(32'b0), //input [31:0] wdata
    .rdata(rdata),
    .frame_sync_o (frame_sync_o),
    .line_sync_o (line_sync_o),
    .outvalid(outvalid),
    .dout(dout)					// output data
);

endmodule
